#include "grind.h"

int isign(double); /*  functions.c */

int vectorfield(int fldstp) {
  double stepsize;
  double x, y, zz;
  int i, j, k;
  static double *pop=NULL, *dpop=NULL;
  int origmode;

  if (pop == NULL) {
    pop = dcalloc(nvar, "'pop' in vectorfield()");
    dpop = dcalloc(nvar, "'dpop' in vectorfield()");
  }

  stepsize = (axis_opt ? 1./((double)fldstp-1.0) : 1./(double)fldstp);
  zz = (axis_opt ? 0.0 : stepsize/2.);

  storeaxis(true);
  origmode = mode_opt;
  /* mode_opt = dim2; */
  for (i=0, x=zz; i<fldstp; i++, x+=stepsize) {
    setax(istate, x, X_AXIS);
    for (j=0, y=zz; j<fldstp; j++, y+=stepsize) {
      setax(istate, y, Y_AXIS);
      fcn(istate, dpop);
      for (k=0; k<nvar; k++)
	dpop[k] = (double)isign(dpop[k]);
      triangle(istate, dpop);
    }
  }
  mode_opt = origmode;
  storeaxis(false);
  return 1;
}
